#include "NatasConfig.h"

CNatasConfig::CNatasConfig()
{
	bRealTime=FALSE;
	BOOL bLogFile=FALSE;
	int NetAdapterNr=0;
}

CNatasConfig::~CNatasConfig()
{

}

void CNatasConfig::ReadConfigFromRegistry(){
	PHKEY phk=(PHKEY)malloc(sizeof(HKEY));	
	BYTE *buf=(BYTE*)malloc(500);
	unsigned long bufsize;
	unsigned short temp;
	int i_tmp;
	    

	if(ERROR_SUCCESS==RegOpenKeyEx(HKEY_CURRENT_USER,"Software\\iNTEx\\Natas\\Config\0",0,KEY_READ,phk)) {
		
		ZeroMemory(buf,500);
		bufsize=500;
		if(ERROR_SUCCESS==RegQueryValueEx(*phk,"LogFileName\0",NULL,NULL,buf,&bufsize))
			strcpy(LogFileName,(char*)buf);

		ZeroMemory(buf,500);
		bufsize=500;
		if(ERROR_SUCCESS==RegQueryValueEx(*phk,"PWLogFileName\0",NULL,NULL,buf,&bufsize))
			strcpy(PWLogFileName,(char*)buf);

		ZeroMemory(buf,500);
		bufsize=500;
		if(ERROR_SUCCESS==RegQueryValueEx(*phk,"HTTPLogFileName\0",NULL,NULL,buf,&bufsize))
			strcpy(HTTPLogFileName,(char*)buf);

		ZeroMemory(buf,500);
		bufsize=500;
		if(ERROR_SUCCESS==RegQueryValueEx(*phk,"SourceAddress\0",NULL,NULL,buf,&bufsize)) 
			strcpy(SourceAddress,(char*)buf);

		ZeroMemory(buf,500);
		bufsize=500;
		if(ERROR_SUCCESS==RegQueryValueEx(*phk,"TargetAddress\0",NULL,NULL,buf,&bufsize))
			strcpy(TargetAddress,(char*)buf);

		ZeroMemory(buf,500);
		bufsize=500;
		if(ERROR_SUCCESS==RegQueryValueEx(*phk,"SourcePort\0",NULL,NULL,buf,&bufsize)){
			sscanf((char*)buf,"%d",&temp);
			memcpy(&SourcePort,&temp,sizeof(unsigned short));
		}

		ZeroMemory(buf,500);		
		bufsize=500;
		if(ERROR_SUCCESS==RegQueryValueEx(*phk,"TargetPort\0",NULL,NULL,buf,&bufsize)){
			sscanf((char*)buf,"%d",&temp);
			memcpy(&TargetPort,&temp,sizeof(unsigned short));
		}

		ZeroMemory(buf,500);
		bufsize=500;
		if(ERROR_SUCCESS==RegQueryValueEx(*phk,"NetAdapterNr\0",NULL,NULL,buf,&bufsize)) {
			sscanf((char*)buf,"%d",&i_tmp);
			memcpy(&NetAdapterNr,&i_tmp,sizeof(int));
		}

		ZeroMemory(buf,500);
		bufsize=500;
		if(ERROR_SUCCESS==RegQueryValueEx(*phk,"FilterCombination\0",NULL,NULL,buf,&bufsize)) {
			sscanf((char*)buf,"%d",&i_tmp);
			memcpy(&Combination,&i_tmp,sizeof(int));
		}

		ZeroMemory(buf,500);
		bufsize=500;
		if(ERROR_SUCCESS==RegQueryValueEx(*phk,"Enable Logfile\0",NULL,NULL,buf,&bufsize)) {
			sscanf((char*)buf,"%d",&temp);
			if(temp) bLogFile=TRUE;
			else bLogFile=FALSE;
		}

		ZeroMemory(buf,500);
		bufsize=500;
		if(ERROR_SUCCESS==RegQueryValueEx(*phk,"Enable PWLogfile\0",NULL,NULL,buf,&bufsize)) {
			sscanf((char*)buf,"%d",&temp);
			if(temp) bPWLogFile=TRUE;
			else bPWLogFile=FALSE;
		}

		ZeroMemory(buf,500);
		bufsize=500;
		if(ERROR_SUCCESS==RegQueryValueEx(*phk,"Enable HTTPLogfile\0",NULL,NULL,buf,&bufsize)) {
			sscanf((char*)buf,"%d",&temp);
			if(temp) bHTTPLogFile=TRUE;
			else bHTTPLogFile=FALSE;
		}

		ZeroMemory(buf,500);		
		bufsize=500;
		if(ERROR_SUCCESS==RegQueryValueEx(*phk,"Enable Realtime\0",NULL,NULL,buf,&bufsize)) {
			sscanf((char*)buf,"%d",&temp);
			if(temp) bRealTime=TRUE;
			else bRealTime=FALSE;
		}

		RegCloseKey(HKEY_CURRENT_USER);
	} 
	free(phk);
	free(buf);
}

void CNatasConfig::WriteConfigToRegistry(){
	HKEY hk=(HKEY)malloc(sizeof(HKEY));
	HKEY hk2=(HKEY)malloc(sizeof(HKEY));
	char temp[500];

	if(ERROR_SUCCESS==RegConnectRegistry(NULL,HKEY_CURRENT_USER,&hk))
		if(ERROR_SUCCESS==RegCreateKey(hk,"Software\\iNTEx\0",&hk2))
			if(ERROR_SUCCESS==RegCreateKey(hk,"Software\\iNTEx\\Natas\0",&hk2))
				if(ERROR_SUCCESS==RegCreateKey(hk,"Software\\iNTEx\\Natas\\Config\0",&hk2)) {
											
					RegSetValueEx(hk2,"LogFileName",0,REG_SZ,(const unsigned char*)LogFileName,strlen(LogFileName));

					RegSetValueEx(hk2,"PWLogFileName",0,REG_SZ,(const unsigned char*)PWLogFileName,strlen(PWLogFileName));

					RegSetValueEx(hk2,"HTTPLogFileName",0,REG_SZ,(const unsigned char*)HTTPLogFileName,strlen(HTTPLogFileName));
					
					RegSetValueEx(hk2,"SourceAddress",0,REG_SZ,(const unsigned char*)SourceAddress,strlen(SourceAddress));

					RegSetValueEx(hk2,"TargetAddress",0,REG_SZ,(const unsigned char*)TargetAddress,strlen(TargetAddress));

					sprintf(temp,"%d\0",SourcePort);
					RegSetValueEx(hk2,"SourcePort",0,REG_SZ,(const unsigned char*)temp,strlen(temp));

					sprintf(temp,"%d\0",TargetPort);
					RegSetValueEx(hk2,"TargetPort",0,REG_SZ,(const unsigned char*)temp,strlen(temp));

					sprintf(temp,"%d\0",NetAdapterNr);
					RegSetValueEx(hk2,"NetAdapterNr",0,REG_SZ,(const unsigned char*)temp,strlen(temp));

					sprintf(temp,"%d\0",Combination);
					RegSetValueEx(hk2,"FilterCombination",0,REG_SZ,(const unsigned char*)temp,strlen(temp));

					if(bLogFile) sprintf(temp,"1");
					else sprintf(temp,"0");
					RegSetValueEx(hk2,"Enable Logfile",0,REG_SZ,(const unsigned char*)temp,strlen(temp));

					if(bPWLogFile) sprintf(temp,"1");
					else sprintf(temp,"0");
					RegSetValueEx(hk2,"Enable PWLogfile",0,REG_SZ,(const unsigned char*)temp,strlen(temp));

					if(bHTTPLogFile) sprintf(temp,"1");
					else sprintf(temp,"0");
					RegSetValueEx(hk2,"Enable HTTPLogfile",0,REG_SZ,(const unsigned char*)temp,strlen(temp));

					if(bRealTime) sprintf(temp,"1");
					else sprintf(temp,"0");
					RegSetValueEx(hk2,"Enable Realtime",0,REG_SZ,(const unsigned char*)temp,strlen(temp));

					RegFlushKey(hk2);
					RegCloseKey(hk2);
					RegCloseKey(hk);
	
	} else MessageBox(NULL,"Error saving preferences in Registry!","Alert!",MB_OK);

	free(hk2);
	free(hk);
}
